import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u - 1, v - 1))
    
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))

    def bfs(start_node, max_dist):
        q = collections.deque([(start_node, 0)])
        visited = {start_node}
        reachable = set()
        while q:
            curr_node, dist = q.popleft()
            reachable.add(curr_node)
            if dist >= max_dist:
                continue
            for u, v in edges:
                neighbor = None
                if u == curr_node and v not in visited:
                    neighbor = v
                elif v == curr_node and u not in visited:
                    neighbor = u
                if neighbor is not None:
                    q.append((neighbor, dist + 1))
                    visited.add(neighbor)
        return reachable

    protected_warehouses = set()
    for guard_pos, guard_range in guards:
        protected_warehouses.update(bfs(guard_pos, guard_range))

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*(w + 1 for w in protected_warehouses))
    

solve()